"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("./watcher");
var ConsoleWatcher = (function (_super) {
    __extends(ConsoleWatcher, _super);
    function ConsoleWatcher() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ConsoleWatcher.prototype.setup = function () {
        if (console) {
            this.program
                .watch("Print to console log.", function (_a) {
                var find = _a.find, record = _a.record;
                var log = find("console/log");
                return [log.add("text", log.text)];
            })
                .asDiffs(function (_a) {
                var adds = _a.adds;
                for (var _i = 0, adds_1 = adds; _i < adds_1.length; _i++) {
                    var _b = adds_1[_i], log = _b[0], _ = _b[1], text = _b[2];
                    console.log(text);
                }
            })
                .watch("Print to console error.", function (_a) {
                var find = _a.find, record = _a.record;
                var log = find("console/error");
                return [log.add("text", log.text)];
            })
                .asDiffs(function (_a) {
                var adds = _a.adds;
                for (var _i = 0, adds_2 = adds; _i < adds_2.length; _i++) {
                    var _b = adds_2[_i], log = _b[0], _ = _b[1], text = _b[2];
                    console.error(text);
                }
            })
                .watch("Print to console warn.", function (_a) {
                var find = _a.find, record = _a.record;
                var log = find("console/warn");
                return [log.add("text", log.text)];
            })
                .asDiffs(function (_a) {
                var adds = _a.adds;
                for (var _i = 0, adds_3 = adds; _i < adds_3.length; _i++) {
                    var _b = adds_3[_i], log = _b[0], _ = _b[1], text = _b[2];
                    console.warn(text);
                }
            });
        }
    };
    return ConsoleWatcher;
}(watcher_1.Watcher));
exports.ConsoleWatcher = ConsoleWatcher;
watcher_1.Watcher.register("console", ConsoleWatcher);
//# sourceMappingURL=console.js.map