import { RawValue } from "./watcher";
import { DOMWatcher } from "./dom";
import { HTMLWatcher } from "./html";
export interface Instance extends SVGElement {
    __element?: RawValue;
    __styles?: RawValue[];
    __sort?: RawValue;
}
export declare class SVGWatcher extends DOMWatcher<Instance> {
    tagPrefix: string;
    html: HTMLWatcher;
    createInstance(id: RawValue, element: RawValue, tagname: RawValue): Instance;
    getInstance(id: RawValue): Instance | undefined;
    createRoot(id: RawValue): undefined;
    addAttribute(instance: Instance, attribute: RawValue, value: RawValue): void;
    removeAttribute(instance: Instance, attribute: RawValue, value: RawValue): void;
    setup(): void;
}
