"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("./watcher");
var SystemWatcher = (function (_super) {
    __extends(SystemWatcher, _super);
    function SystemWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.timers = {};
        return _this;
    }
    SystemWatcher.prototype.getTime = function (changes, timer, tick, date) {
        var multiplicity = -1;
        if (!date) {
            multiplicity = 1;
            date = new Date();
        }
        changes.push([timer, "year", date.getFullYear(), multiplicity], [timer, "month", date.getMonth() + 1, multiplicity], [timer, "day", date.getDate(), multiplicity], [timer, "weekday", date.getDay() + 1, multiplicity], [timer, "hour", date.getHours(), multiplicity], [timer, "minute", date.getMinutes(), multiplicity], [timer, "second", date.getSeconds(), multiplicity], [timer, "millisecond", date.getMilliseconds(), multiplicity], [timer, "timestamp", date.getTime(), multiplicity], [timer, "tick", tick, multiplicity]);
        return date;
    };
    SystemWatcher.prototype.setup = function () {
        var _this = this;
        var me = this.program;
        me.watch("setup timers", function (_a) {
            var find = _a.find, record = _a.record;
            var timer = find("system/timer");
            return [
                record({ timer: timer, resolution: timer.resolution })
            ];
        });
        me.asObjects(function (_a) {
            var adds = _a.adds, removes = _a.removes;
            Object.keys(adds).forEach(function (id) {
                var _a = adds[id], timer = _a.timer, resolution = _a.resolution;
                var prev;
                var timerHandle = setInterval(function () {
                    var _a = _this.timers[id], prev = _a.prev, tick = _a.tick;
                    var changes = [];
                    if (prev) {
                        _this.getTime(changes, timer, tick, prev);
                    }
                    _this.timers[id].tick = ++tick;
                    _this.timers[id].prev = _this.getTime(changes, timer, tick);
                    me.inputEAVs(changes);
                }, resolution);
                _this.timers[id] = { timer: timerHandle, prev: undefined, tick: 0 };
            });
            console.log("GOT TIMER!", adds);
        });
    };
    return SystemWatcher;
}(watcher_1.Watcher));
exports.SystemWatcher = SystemWatcher;
watcher_1.Watcher.register("system", SystemWatcher);
//# sourceMappingURL=system.js.map