"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("./watcher");
var ui_1 = require("../watchers/ui");
function t(tag) {
    return "tag-browser/" + tag;
}
function collapse() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var all = [];
    for (var _a = 0, args_1 = args; _a < args_1.length; _a++) {
        var sublist = args_1[_a];
        for (var _b = 0, sublist_1 = sublist; _b < sublist_1.length; _b++) {
            var item = sublist_1[_b];
            all.push(item);
        }
    }
    return all;
}
var TagBrowserWatcher = (function (_super) {
    __extends(TagBrowserWatcher, _super);
    function TagBrowserWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.browser = _this.createTagBrowser();
        return _this;
    }
    TagBrowserWatcher.prototype.setup = function () {
        var _this = this;
        this.program
            .watch("Export all tags", function (_a) {
            var find = _a.find, record = _a.record;
            var rec = find();
            return [
                record("child-tag", { "child-tag": rec.tag })
            ];
        })
            .asDiffs(function (diffs) {
            var eavs = [];
            for (var _i = 0, _a = diffs.removes; _i < _a.length; _i++) {
                var _b = _a[_i], e = _b[0], a = _b[1], v = _b[2];
                eavs.push([e, a, v, -1]);
            }
            for (var _c = 0, _d = diffs.adds; _c < _d.length; _c++) {
                var _e = _d[_c], e = _e[0], a = _e[1], v = _e[2];
                eavs.push([e, a, v, 1]);
            }
            if (eavs.length) {
                _this.browser.inputEAVs(eavs);
            }
        })
            .watch("Export all records", function (_a) {
            var find = _a.find, lookup = _a.lookup, choose = _a.choose, record = _a.record;
            var rec = find();
            var _b = lookup(rec), attribute = _b.attribute, value = _b.value;
            // let [attrName] = choose(
            //   () => { attribute == "tag"; return "child-tag"; },
            //   () => attribute
            // );
            return [
                rec.add("tag", "child-record").add(attribute, value)
            ];
        })
            .asDiffs(function (diffs) {
            var eavs = [];
            for (var _i = 0, _a = diffs.removes; _i < _a.length; _i++) {
                var _b = _a[_i], e = _b[0], a = _b[1], v = _b[2];
                // @NOTE: this breaks tag-browser inspecting tag-browser
                if (a === "tag" && v !== "child-record")
                    a = "child-tag";
                eavs.push([e, a, v, -1]);
            }
            for (var _c = 0, _d = diffs.adds; _c < _d.length; _c++) {
                var _e = _d[_c], e = _e[0], a = _e[1], v = _e[2];
                // @NOTE: this breaks tag-browser inspecting tag-browser
                if (a === "tag" && v !== "child-record")
                    a = "child-tag";
                eavs.push([e, a, v, 1]);
            }
            if (eavs.length) {
                _this.browser.inputEAVs(eavs);
            }
        });
    };
    TagBrowserWatcher.prototype.createTagBrowser = function () {
        var _this = this;
        var prog = new watcher_1.Program("Tag Browser");
        prog.attach("ui");
        var _a = ui_1.UIWatcher.helpers, $style = _a.$style, $row = _a.$row, $column = _a.$column, $text = _a.$text, $elem = _a.$elem;
        //--------------------------------------------------------------------
        // Custom UI Components
        //--------------------------------------------------------------------
        // Tag Button
        prog
            .bind("Tag button component", function (_a) {
            var find = _a.find, record = _a.record;
            var tagButton = find("tag-browser/tag");
            var tag = tagButton.target;
            return [
                tagButton.add({ tag: "ui/button", class: "inset", text: tag, sort: tag })
            ];
        })
            .commit("When a tag button is clicked, update the view target.", function (_a) {
            var find = _a.find, record = _a.record;
            var click = find("html/event/click");
            var element = click.element;
            element.tag == "tag-browser/tag";
            var view = find("tag-browser/view");
            return [
                view.remove("target").add("target", element.target)
            ];
        });
        // @FIXME: Work around for a bug that occurs when leaving a record open and then letting it be retracted and reasserted
        // .commit("When a tag button is clicked, clear any open child records", ({find, record}) => {
        //   let click = find("html/event/click");
        //   let {element} = click;
        //   element.tag == "tag-browser/tag";
        //   //let view = find("tag-browser/view");
        //   //view.target != element.target;
        //   let openChildren = find("tag-browser/record");
        //   openChildren.open;
        //   return [
        //     openChildren.remove("open")
        //   ];
        // });
        // Record
        prog
            .bind("Record component (closed)", function (_a) {
            var find = _a.find, record = _a.record;
            var childRecord = find("tag-browser/record");
            return [
                childRecord.add({
                    tag: "ui/column",
                    style: record({ border: "1px solid gray", margin: 10, padding: 10 }),
                    rec: childRecord.target,
                    children: [
                        record("ui/row", "tag-browser/record-header", { sort: 0, rec: childRecord.target }).add("children", [
                            record("html/element", { tagname: "div", class: "hexagon" }),
                            record("ui/text", { rec: childRecord.target, text: childRecord.target.displayName })
                        ])
                    ]
                })
            ];
        })
            .bind("Record component (open)", function (_a) {
            var find = _a.find, lookup = _a.lookup, record = _a.record;
            var childRecord = find("tag-browser/record", { open: "true" });
            var _b = lookup(childRecord.target), attribute = _b.attribute, value = _b.value;
            attribute != "tag";
            return [
                childRecord.add({
                    children: [
                        record("tag-browser/record-attribute", { rec: childRecord.target, attr: attribute }).add("val", value)
                    ]
                })
            ];
        })
            .commit("Clicking a record toggles it open/closed", function (_a) {
            var find = _a.find, choose = _a.choose;
            var recordHeader = find("tag-browser/record-header");
            var record = find("tag-browser/record", { children: recordHeader });
            find("html/event/click", { element: recordHeader });
            var open = choose(function () { record.open == "true"; return "false"; }, function () { return "true"; })[0];
            return [
                record.remove("open").add("open", open)
            ];
        });
        // Record Attribute
        prog
            .bind("Record attribute component", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var recordAttribute = find("tag-browser/record-attribute");
            var target = find("tag-browser/view").target;
            var attrName = choose(function () { recordAttribute.attr == "child-tag"; return "tag"; }, function () { return recordAttribute.attr; })[0];
            var rec = recordAttribute.rec, val = recordAttribute.val;
            return [
                recordAttribute.add({ tag: "ui/row",
                    children: [
                        record("ui/text", { sort: 0, text: attrName + ":", rec: rec, style: record({ "margin-right": 10 }) }),
                        record("ui/column", { sort: 1, rec: rec, attrName: attrName }) // @FIXME: These attrs from the parent shouldn't need to be on the children.
                            .add("children", record("tag-browser/record-value", { rec: rec, attr: attrName, val: val, "active-input": "foo" }))
                    ]
                })
            ];
        });
        // Record Value
        prog
            .bind("Record value component (as tag)", function (_a) {
            var find = _a.find, record = _a.record;
            var recordValue = find("tag-browser/record-value");
            var val = recordValue.val;
            var childTag = find("child-tag", { "child-tag": val });
            return [
                recordValue.add({ tag: "tag-browser/tag", target: val })
            ];
        })
            .bind("Record value component (as record)", function (_a) {
            var find = _a.find, record = _a.record;
            var recordValue = find("tag-browser/record-value");
            var childRecord = find("child-record");
            childRecord == recordValue.val;
            return [
                recordValue.add({ tag: "tag-browser/record", target: childRecord })
            ];
        })
            .bind("Record value component (as raw value)", function (_a) {
            var find = _a.find, not = _a.not, record = _a.record;
            var recordValue = find("tag-browser/record-value");
            // @FIXME: Not is *still* busted
            not(function () { return recordValue.tag == "tag-browser/tag"; });
            not(function () { return recordValue.tag == "tag-browser/record"; });
            var val = recordValue.val;
            return [
                recordValue.add({ tag: "ui/text", sort: val, text: val })
            ];
        });
        // Tag Cloud
        prog.bind("List all tags in the tag cloud.", function (_a) {
            var find = _a.find, not = _a.not, record = _a.record;
            var cloud = find("tag-browser/cloud");
            var rec = find("child-tag");
            var tag = rec["child-tag"];
            return [
                cloud.add("children", record("tag-browser/tag", { target: tag }))
            ];
        });
        // Tag View
        prog
            .bind("Show the targeted tag", function (_a) {
            var find = _a.find, record = _a.record;
            var view = find("tag-browser/view");
            var target = view.target;
            return [
                view.add("children", record("ui/text", { text: "Current tag: " + target, sort: 0 }))
            ];
        })
            .bind("Show records with the targeted tag", function (_a) {
            var find = _a.find, not = _a.not, record = _a.record;
            var view = find("tag-browser/view");
            var targetedRecord = find("child-record", { "child-tag": view.target });
            return [
                view.add("children", record("ui/row", {
                    sort: 1,
                    style: record({ "flex-wrap": "wrap", "align-items": "flex-start" }),
                }).add("children", record("tag-browser/record", { target: targetedRecord, "active-tag": view.target })))
            ];
        })
            .watch("When the view target changes, mark it as the active tag in the child program", function (_a) {
            var find = _a.find, record = _a.record;
            var view = find("tag-browser/view");
            return [
                record("tag-browser/active-tag", { "active-tag": view.target })
            ];
        })
            .asDiffs(function (diffs) {
            var eavs = [];
            for (var _i = 0, _a = diffs.removes; _i < _a.length; _i++) {
                var _b = _a[_i], e = _b[0], a = _b[1], v = _b[2];
                eavs.push([e, a, v, -1]);
            }
            for (var _c = 0, _d = diffs.adds; _c < _d.length; _c++) {
                var _e = _d[_c], e = _e[0], a = _e[1], v = _e[2];
                eavs.push([e, a, v, 1]);
            }
            if (eavs.length) {
                _this.program.inputEAVs(eavs);
            }
        });
        // Display Name aliasing
        prog
            .bind("Alias display names", function (_a) {
            var find = _a.find, choose = _a.choose;
            var record = find("child-record");
            var name = choose(
            //() => record.displayName,
            function () { return record.name; }, function () { return "???"; })[0];
            return [
                record.add("displayName", name)
            ];
        });
        // Create root UI
        var changes = collapse($column({ tag: t("root") }, [
            $row({ tag: t("cloud"), style: $style({ "flex-wrap": "wrap" }) }, []),
            $column({ tag: t("view") }, [])
        ]), $elem("html/element", {
            tagname: "style",
            text: "\n          .hexagon {\n            width: 22px;\n            height: 22px;\n            margin-right: 5px;\n            vertical-align: middle;\n            border-radius: 100px;\n            border: 2px solid #AAA;\n          }\n        "
        }));
        prog.inputEAVs(changes);
        return prog;
    };
    return TagBrowserWatcher;
}(watcher_1.Watcher));
exports.TagBrowserWatcher = TagBrowserWatcher;
watcher_1.Watcher.register("tag browser", TagBrowserWatcher);
//# sourceMappingURL=tag-browser.js.map