import { Token } from "chevrotain";
export declare class EveError {
    static ID: number;
    type: string;
    id: string;
    blockId: string;
    message: string;
    start: number;
    stop: number;
    context?: any;
    spanId: string;
    constructor(blockId: string, start: number, stop: number, message: string, context?: any);
    injectSpan(spans: any, extraInfo: any): void;
}
export declare function parserErrors(errors: any[], parseInfo: {
    blockId: string;
    blockStart: number;
    spans: any[];
    extraInfo: any;
    tokens: Token[];
}): EveError[];
export declare function unprovidedVariableGroup(block: any, variables: any): EveError;
export declare function blankScan(block: any, scan: any): EveError;
export declare function invalidLookupAction(block: any, action: any): EveError;
export declare function unimplementedExpression(block: any, expression: any): EveError;
export declare function incompatabileConstantEquality(block: any, left: any, right: any): EveError;
export declare function incompatabileVariableToConstantEquality(block: any, variable: any, variableValue: any, constant: any): EveError;
export declare function incompatabileTransitiveEquality(block: any, variable: any, value: any): EveError;
export declare function unrecognisedFunctionAttribute(block: any, expression: any, attribute: any): EveError;
export declare var messages: {
    unclosedPair: (type: string) => string;
    extraCloseChar: (char: string) => string;
    unprovidedVariable: (varName: string) => string;
    unrecognisedFunctionAttribute: (attributeName: string, functionName: string) => string;
    unimplementedExpression: (op: string) => string;
    blankScan: () => string;
    invalidLookupAction: (missing: string[]) => string;
    neverEqual: (left: string, right: string) => string;
    variableNeverEqual: (variable: any, value: string, right: string) => string;
    actionNonTag: (found: string) => string;
    actionRawIdentifier: (found: string) => string;
};
