export declare type TimeReturn = number;
export declare class PerformanceTracker {
    blocks: {
        [block: string]: {
            times: {
                [property: string]: number;
            };
            counts: {
                [property: string]: number;
            };
        };
    };
    activeBlock: string;
    activeProperties: {
        [property: string]: TimeReturn;
    };
    times: {
        [property: string]: number;
    };
    counts: {
        [property: string]: number;
    };
    now: () => TimeReturn;
    elapsed: (start: TimeReturn) => TimeReturn;
    _makePropertyHolder(props?: string[]): any;
    constructor();
    reset(): void;
    block(name: string): void;
    blockEnd(name: string): void;
    blockTime(property: string): void;
    blockTimeEnd(property: string): void;
    time(property: string): void;
    timeEnd(property: string): void;
    serialize(): string;
}
export declare class NoopPerformanceTracker extends PerformanceTracker {
    blocks: {
        [block: string]: {
            times: {
                [property: string]: number;
            };
            counts: {
                [property: string]: number;
            };
        };
    };
    times: {
        [property: string]: number;
    };
    counts: {
        [property: string]: number;
    };
    now: () => TimeReturn;
    elapsed: (start: TimeReturn) => TimeReturn;
    constructor();
    reset(): void;
    time(property: string): void;
    timeEnd(property: string): void;
    block(name: string): void;
    blockEnd(name: string): void;
    blockTime(property: string): void;
    blockTimeEnd(property: string): void;
}
export declare var now: () => any;
export declare var elapsed: (start: any) => any;
