"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var runtime_1 = require("./runtime");
var dateformat = require("dateformat");
//--------------------------------------------------------------------
// Comparisons
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "compare/>",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a > b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/>=",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a >= b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/<",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a < b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/<=",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a <= b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/!=",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a != b) ? [] : undefined;
    }
});
runtime_1.makeFunction({
    name: "compare/==",
    args: { a: "number", b: "number" },
    returns: {},
    apply: function (a, b) {
        return (a == b) ? [] : undefined;
    }
});
//--------------------------------------------------------------------
// Math
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "math/+",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a + b];
    }
});
runtime_1.makeFunction({
    name: "math/-",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a - b];
    }
});
runtime_1.makeFunction({
    name: "math/*",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a * b];
    }
});
runtime_1.makeFunction({
    name: "math//",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [a / b];
    }
});
runtime_1.makeFunction({
    name: "math/floor",
    args: { value: "number" },
    returns: { result: "number" },
    apply: function (value) {
        return [Math.floor(value)];
    }
});
runtime_1.makeFunction({
    name: "math/ceiling",
    args: { value: "number" },
    returns: { result: "number" },
    apply: function (value) {
        return [Math.ceil(value)];
    }
});
runtime_1.makeFunction({
    name: "math/round",
    args: { value: "number" },
    returns: { result: "number" },
    apply: function (value) {
        return [Math.round(value)];
    }
});
runtime_1.makeFunction({
    name: "math/sin",
    args: { degrees: "number" },
    returns: { result: "number" },
    apply: function (degrees) {
        return [Math.sin(degrees / 180 * Math.PI)];
    }
});
runtime_1.makeFunction({
    name: "math/cos",
    args: { degrees: "number" },
    returns: { result: "number" },
    apply: function (degrees) {
        return [Math.cos(degrees / 180 * Math.PI)];
    }
});
runtime_1.makeFunction({
    name: "math/tan",
    args: { degrees: "number" },
    returns: { result: "number" },
    apply: function (degrees) {
        return [Math.tan(degrees / 180 * Math.PI)];
    }
});
runtime_1.makeFunction({
    name: "math/max",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [Math.max(a, b)];
    }
});
runtime_1.makeFunction({
    name: "math/min",
    args: { a: "number", b: "number" },
    returns: { result: "number" },
    apply: function (a, b) {
        return [Math.min(a, b)];
    }
});
runtime_1.makeFunction({
    name: "math/mod",
    args: { value: "number", by: "number" },
    returns: { result: "number" },
    apply: function (value, by) {
        return [value % by];
    }
});
runtime_1.makeFunction({
    name: "math/absolute",
    args: { value: "number" },
    returns: { result: "number" },
    apply: function (value) {
        return [Math.abs(value)];
    }
});
runtime_1.makeFunction({
    name: "math/pow",
    args: { value: "number", exponent: "number" },
    returns: { result: "number" },
    apply: function (value, exponent) {
        return [Math.pow(value, exponent)];
    }
});
runtime_1.makeFunction({
    name: "math/to-fixed",
    args: { value: "number", to: "number" },
    returns: { result: "string" },
    apply: function (value, to) {
        if (typeof value === "number") {
            return [value.toFixed(to)];
        }
    }
});
runtime_1.makeFunction({
    name: "math/convert-base",
    args: { value: "number", to: "number" },
    returns: { result: "string" },
    apply: function (value, to) {
        if (typeof value === "number" && to > 1 && to < 37) {
            return [value.toString(to)];
        }
    }
});
runtime_1.makeMultiFunction({
    name: "math/range",
    args: { start: "number", stop: "number" },
    returns: { result: "string" },
    estimate: function (context, prefix) {
        var _a = this.resolve(prefix), start = _a.start, stop = _a.stop;
        if (typeof start !== "number" || typeof stop !== "number")
            return 0;
        if (start > stop) {
            return start - stop;
        }
        else {
            return stop - start;
        }
    },
    apply: function (start, stop, step) {
        if (step === void 0) { step = 1; }
        if (typeof start !== "number" || typeof stop !== "number" || typeof step !== "number")
            return;
        if (start > stop) {
            _a = [start, stop], stop = _a[0], start = _a[1];
        }
        var outputs = [];
        for (var ix = start; ix <= stop; ix += step) {
            outputs.push([ix]);
        }
        return outputs;
        var _a;
    }
});
//--------------------------------------------------------------------
// String
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "string/replace",
    args: { text: "string", replace: "string", with: "string" },
    returns: { result: "string" },
    apply: function (text, replace, _with) {
        var result = text.split(replace).join(_with);
        return [result];
    }
});
runtime_1.makeFunction({
    name: "string/get",
    args: { text: "string", at: "number" },
    returns: { result: "string" },
    apply: function (text, at) {
        if (at > text.length)
            return;
        return [text[at - 1]];
    }
});
runtime_1.makeFunction({
    name: "string/uppercase",
    args: { text: "string" },
    returns: { result: "string" },
    apply: function (text) {
        return [text.toLocaleUpperCase()];
    }
});
runtime_1.makeFunction({
    name: "string/lowercase",
    args: { text: "string" },
    returns: { result: "string" },
    apply: function (text) {
        return [text.toLocaleLowerCase()];
    }
});
runtime_1.makeFunction({
    name: "string/index-of",
    args: { text: "string", substring: "string" },
    returns: { result: "number" },
    apply: function (text, substring) {
        var ix = ("" + text).indexOf(substring);
        if (ix == -1)
            return;
        return [ix];
    }
});
runtime_1.makeFunction({
    name: "string/codepoint-length",
    args: { text: "string" },
    returns: { result: "number" },
    apply: function (text) {
        if (typeof text !== "string")
            return;
        return [text.length];
    }
});
//--------------------------------------------------------------------
// Random
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "random/number",
    args: { seed: "any" },
    returns: { result: "number" },
    initialState: {},
    apply: function (seed) {
        var state = this.state;
        var result = state[seed];
        if (result === undefined) {
            result = state[seed] = Math.random();
        }
        return [result];
    }
});
//--------------------------------------------------------------------
// Logic
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "logic/toggle",
    args: { value: "string" },
    returns: { result: "string" },
    apply: function (value) {
        if (value === "true")
            return ["false"];
        if (value === "false")
            return ["true"];
        return [];
    }
});
//--------------------------------------------------------------------
// Date
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "date/format",
    args: { timestamp: "number", format: "string" },
    returns: { result: "string" },
    apply: function (timestamp, format) {
        return [dateformat(timestamp, format)];
    }
});
//--------------------------------------------------------------------
// Eve internal
//--------------------------------------------------------------------
runtime_1.makeFunction({
    name: "eve/internal/gen-id",
    args: {},
    variadic: true,
    returns: { result: "string" },
    apply: function (values) {
        // @FIXME: This is going to be busted in subtle cases.
        //   If a record exists with a "1" and 1 value for the same
        //   attribute, they'll collapse for gen-id, but won't join
        //   elsewhere.  This means aggregate cardinality will disagree with
        //   action node cardinality.
        return [values.join("|")];
    }
});
runtime_1.makeFunction({
    name: "eve/internal/concat",
    args: {},
    variadic: true,
    returns: { result: "string" },
    apply: function (values) {
        return [values.join("")];
    }
});
var SumAggregate = (function (_super) {
    __extends(SumAggregate, _super);
    function SumAggregate() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = "Sum";
        return _this;
    }
    SumAggregate.prototype.add = function (state, resolved) {
        state.total += resolved[0];
        return state;
    };
    SumAggregate.prototype.remove = function (state, resolved) {
        state.total -= resolved[0];
        return state;
    };
    SumAggregate.prototype.getResult = function (state) {
        return state.total;
    };
    SumAggregate.prototype.newResultState = function () {
        return { total: 0 };
    };
    ;
    return SumAggregate;
}(runtime_1.AggregateNode));
exports.SumAggregate = SumAggregate;
//# sourceMappingURL=stdlib.js.map