"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var watcher_1 = require("./watcher");
var FileWatcher = (function (_super) {
    __extends(FileWatcher, _super);
    function FileWatcher() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FileWatcher.prototype.setup = function () {
        var me = this.program;
        me.load("\nAttach errors to the associated file\n~~~\nsearch\nerror = [#file/error file code message]\n\nbind\nfile.error += error\n~~~     \n  ");
        if (fs.readFile) {
            me.watch("Read a file.", function (_a) {
                var find = _a.find, record = _a.record, choose = _a.choose;
                var file = find("file/read");
                var encoding = choose(function () { return file.encoding; }, function () { return "utf-8"; });
                return [
                    record({ file: file, path: file.path, encoding: encoding })
                ];
            })
                .asObjects(function (_a) {
                var adds = _a.adds, removes = _a.removes;
                Object.keys(adds).forEach(function (id) {
                    var _a = adds[id], file = _a.file, path = _a.path, encoding = _a.encoding;
                    fs.readFile(path, { encoding: encoding }, function (err, contents) {
                        if (!err) {
                            me.inputEAVs([[file, "contents", contents]]);
                        }
                        else {
                            var id_1 = file + "|error";
                            var changes = [];
                            changes.push([id_1, "tag", "file/error"], [id_1, "file", file], [id_1, "code", "" + err.code], [id_1, "message", "" + err.message]);
                            me.inputEAVs(changes);
                        }
                    });
                });
            });
        }
        if (fs.writeFile) {
            me.watch("Write a file.", function (_a) {
                var find = _a.find, record = _a.record, choose = _a.choose;
                var file = find("file/write");
                var encoding = choose(function () { return file.encoding; }, function () { return "utf-8"; });
                return [
                    record({ file: file, path: file.path, encoding: encoding, contents: file.contents })
                ];
            })
                .asObjects(function (_a) {
                var adds = _a.adds, removes = _a.removes;
                Object.keys(adds).forEach(function (id) {
                    var _a = adds[id], file = _a.file, path = _a.path, contents = _a.contents, encoding = _a.encoding;
                    fs.writeFile(path, contents, { encoding: encoding }, function (err) {
                        if (!err) {
                            me.inputEAVs([[file, "tag", "file/complete"]]);
                        }
                        else {
                            var id_2 = file + "|error";
                            var changes = [];
                            changes.push([id_2, "tag", "file/error"], [id_2, "file", file], [id_2, "code", "" + err.code], [id_2, "message", "" + err.message]);
                            me.inputEAVs(changes);
                        }
                    });
                });
            });
        }
    };
    return FileWatcher;
}(watcher_1.Watcher));
exports.FileWatcher = FileWatcher;
watcher_1.Watcher.register("file", FileWatcher);
//# sourceMappingURL=file.js.map