"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("./watcher");
var dom_1 = require("./dom");
var SVGWatcher = (function (_super) {
    __extends(SVGWatcher, _super);
    function SVGWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tagPrefix = "svg";
        return _this;
    }
    SVGWatcher.prototype.createInstance = function (id, element, tagname) {
        var elem = document.createElementNS("http://www.w3.org/2000/svg", tagname);
        elem.__element = element;
        elem.__styles = [];
        return elem;
    };
    SVGWatcher.prototype.getInstance = function (id) {
        if (this.instances[id])
            return this.instances[id];
        if (this.html.instances[id])
            return this.html.instances[id];
    };
    SVGWatcher.prototype.createRoot = function (id) {
        // This is delegated to the HTML watcher for #svg/roots, and it's nonsensical to try to make any other svg element a root.
        return undefined;
    };
    SVGWatcher.prototype.addAttribute = function (instance, attribute, value) {
        // @TODO: Namespace attributes as appropriate.
        instance.setAttribute(attribute, value);
    };
    SVGWatcher.prototype.removeAttribute = function (instance, attribute, value) {
        // @TODO: Namespace attributes as appropriate.
        instance.removeAttribute(attribute);
    };
    SVGWatcher.prototype.setup = function () {
        this.html = this.program.attach("html");
        this.tagPrefix = "svg";
        _super.prototype.setup.call(this);
        this.program
            .bind("Create an instance for each child of an svg/root.", function (_a) {
            var find = _a.find, record = _a.record, lib = _a.lib;
            var elem = find("svg/element");
            var parentElem = find("svg/root", { children: elem });
            var parent = find("html/instance", { element: parentElem });
            return [
                record("svg/instance", { element: elem, tagname: elem.tagname, parent: parent })
            ];
        })
            .bind("Decorate a svg roots as html.", function (_a) {
            var find = _a.find;
            var elem = find("svg/root");
            return [elem.add({ tag: "html/element", tagname: "svg" })];
        })
            .bind("Decorate line as svg.", function (_a) {
            var find = _a.find;
            var elem = find("svg/line");
            return [elem.add({ tag: "svg/element", tagname: "line" })];
        })
            .bind("Decorate circle as svg.", function (_a) {
            var find = _a.find;
            var elem = find("svg/circle");
            return [elem.add({ tag: "svg/element", tagname: "circle" })];
        })
            .bind("Decorate rect as svg.", function (_a) {
            var find = _a.find;
            var elem = find("svg/rect");
            return [elem.add({ tag: "svg/element", tagname: "rect" })];
        })
            .bind("Decorate text as svg.", function (_a) {
            var find = _a.find;
            var elem = find("svg/text");
            return [elem.add({ tag: "svg/element", tagname: "text" })];
        })
            .bind("Decorate image as svg.", function (_a) {
            var find = _a.find;
            var elem = find("svg/image");
            return [elem.add({ tag: "svg/element", tagname: "image" })];
        });
    };
    return SVGWatcher;
}(dom_1.DOMWatcher));
exports.SVGWatcher = SVGWatcher;
watcher_1.Watcher.register("svg", SVGWatcher);
//# sourceMappingURL=svg.js.map