"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("./watcher");
var uuid_1 = require("uuid");
var UIWatcher = (function (_super) {
    __extends(UIWatcher, _super);
    function UIWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.helpers = UIWatcher.helpers;
        return _this;
    }
    UIWatcher._addAttrs = function (id, attrs, eavs) {
        if (eavs === void 0) { eavs = []; }
        if (attrs) {
            for (var attr in attrs) {
                if (attrs[attr].constructor !== Array) {
                    eavs.push([id, attr, attrs[attr]]);
                }
                else {
                    var vals = attrs[attr];
                    // We have a nested sub-object (i.e. a set of EAVs).
                    if (vals[0].constructor === Array) {
                        var childEAVs = vals;
                        var childId = childEAVs[0][0];
                        eavs.push([id, attr, childId]);
                        for (var _i = 0, childEAVs_1 = childEAVs; _i < childEAVs_1.length; _i++) {
                            var childEAV = childEAVs_1[_i];
                            eavs.push(childEAV);
                        }
                    }
                    else {
                        for (var _a = 0, _b = vals; _a < _b.length; _a++) {
                            var val = _b[_a];
                            eavs.push([id, attr, val]);
                        }
                    }
                }
            }
        }
        return eavs;
    };
    UIWatcher.$elem = function (tag, attrs) {
        var id = uuid_1.v4();
        var eavs = [
            [id, "tag", tag],
        ];
        UIWatcher._addAttrs(id, attrs, eavs);
        return eavs;
    };
    UIWatcher._makeContainer = function (tag) {
        function $container(attrsOrChildren, maybeChildren) {
            var attrs;
            var children;
            if (maybeChildren) {
                attrs = attrsOrChildren;
                children = maybeChildren;
            }
            else {
                children = attrsOrChildren;
            }
            var eavs = UIWatcher.$elem(tag, attrs);
            var id = eavs[0][0];
            for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
                var child = children_1[_i];
                var childId = child[0][0];
                eavs.push([id, "children", childId]);
                for (var _a = 0, child_1 = child; _a < child_1.length; _a++) {
                    var childEAV = child_1[_a];
                    eavs.push(childEAV);
                }
            }
            return eavs;
        }
        return $container;
    };
    UIWatcher.prototype.setup = function () {
        this.program.attach("html");
        this.program
            .bind("Decorate row elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/row");
            return [elem.add("tag", "html/element").add("tagname", "row")];
        })
            .bind("Decorate column elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/column");
            return [elem.add("tag", "html/element").add("tagname", "column")];
        })
            .bind("Decorate spacer elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/spacer");
            return [elem.add("tag", "html/element").add("tagname", "spacer")];
        })
            .bind("Decorate input elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/input");
            return [elem.add("tag", "html/element").add("tagname", "input")];
        })
            .bind("Decorate text elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/text");
            return [elem.add("tag", "html/element").add("tagname", "text")];
        })
            .bind("Decorate a elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/a");
            return [elem.add("tag", "html/element").add("tagname", "a")];
        })
            .bind("Decorate style elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/style");
            return [elem.add("tag", "html/element").add("tagname", "style")];
        })
            .bind("Decorate link elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/link");
            return [elem.add("tag", "html/element").add("tagname", "link")];
        })
            .bind("Decorate div elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/div");
            return [elem.add("tag", "html/element").add("tagname", "div")];
        })
            .bind("Decorate span elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/span");
            return [elem.add("tag", "html/element").add("tagname", "span")];
        })
            .bind("Decorate img elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/img");
            return [elem.add("tag", "html/element").add("tagname", "img")];
        })
            .bind("Decorate h1 elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/h1");
            return [elem.add("tag", "html/element").add("tagname", "h1")];
        })
            .bind("Decorate h2 elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/h2");
            return [elem.add("tag", "html/element").add("tagname", "h2")];
        })
            .bind("Decorate h3 elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/h3");
            return [elem.add("tag", "html/element").add("tagname", "h3")];
        })
            .bind("Decorate ul elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/ul");
            return [elem.add("tag", "html/element").add("tagname", "ul")];
        })
            .bind("Decorate ol elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/ol");
            return [elem.add("tag", "html/element").add("tagname", "ol")];
        })
            .bind("Decorate li elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/li");
            return [elem.add("tag", "html/element").add("tagname", "li")];
        });
        // Buttons
        this.program
            .bind("Decorate button elements as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/button");
            return [elem.add("tag", "html/element").add("tagname", "div").add("class", "button")];
        })
            .bind("Decorate button elements with icons.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/button");
            return [elem.add("class", "iconic").add("class", "ion-" + elem.icon)];
        });
        //--------------------------------------------------------------------
        // Field Table
        //--------------------------------------------------------------------
        this.program
            .bind("Decorate field tables as html.", function (_a) {
            var find = _a.find, record = _a.record;
            var elem = find("ui/field-table");
            return [elem.add({ tag: "html/element", tagname: "table", cellspacing: 0 })];
        })
            .bind("Field tables have a value_row for each AV pair in their fields.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var table = find("ui/field-table");
            var field = table.field;
            var attribute = field.attribute, value = field.value;
            var editable = choose(function () { field.editable == "value"; return "true"; }, function () { return "false"; })[0];
            return [table.add("value_row", [
                    record({ field: field, attribute: attribute, value: value })
                        .add("editable", editable)
                ])];
        })
            .bind("If a table is editable: all attach each specific editing mode.", function (_a) {
            var find = _a.find, choose = _a.choose;
            var table = find("ui/field-table", "ui/editable");
            return [table.add("editable", [
                    // Modify existing
                    "value",
                    "attribute",
                    // Create new,
                    "row",
                    "field"
                ])];
        })
            .bind("A table's fields inherit the editing mode of their table if they don't specify their own.", function (_a) {
            var find = _a.find, choose = _a.choose;
            var table = find("ui/field-table");
            var field = table.field;
            var editable = choose(function () { return field.editable; }, function () { return table.editable; })[0];
            return [field.add("editable", editable)];
        })
            .bind("Create a row for each unique field.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var table = find("ui/field-table");
            var field = table.field;
            return [
                table.add("children", [
                    record("ui/field-table/row", { table: table, field: field })
                ])
            ];
        })
            .commit("If a field is row editable, add value_rows for the field when no empty ones exist.", function (_a) {
            var find = _a.find, not = _a.not, gather = _a.gather, choose = _a.choose, record = _a.record;
            var table = find("ui/field-table");
            var field = table.field;
            field.editable == "row";
            not(function () { return find("ui/field-table/cell", { table: table, field: field, column: "value", value: "" }); });
            var count = choose(function () {
                var cell = find("ui/field-table/cell", { field: field });
                return gather(cell).per(field).count() + 1;
            }, function () { return 1; })[0];
            return [
                table.add("value_row", [
                    record("ui/field-table/value-row/new", { sort: "zz" + count, field: field, attribute: field.attribute, value: "" })
                        .add("editable", "true")
                ])
            ];
        })
            .commit("If a field is row editable, clear any excess empty rows.", function (_a) {
            var find = _a.find, record = _a.record;
            var table = find("ui/field-table");
            var field = table.field;
            field.editable == "row";
            var cell = find("ui/field-table/cell", { table: table, field: field, column: "value", value: "" });
            var other = find("ui/field-table/cell", { table: table, field: field, column: "value", value: "" });
            other.sort > cell.sort;
            return [other.value_row.remove()];
        })
            .commit("If a table is field editable, add a field when no empty ones exist.", function (_a) {
            var find = _a.find, not = _a.not, gather = _a.gather, choose = _a.choose, record = _a.record;
            var table = find("ui/field-table", { editable: "field" });
            not(function () { return find("ui/field-table/attribute", { table: table, column: "attribute", value: "" }); });
            var count = choose(function () {
                table == find("ui/field-table"); // @FIXME: Hackaround aggregate bug.
                return gather(table.field).per(table).count() + 1;
            }, function () { return 1; })[0];
            return [
                table.add("field", [
                    record("ui/field-table/field/new", { sort: "zz" + count, attribute: "", value: "" })
                        .add("editable", table.editable)
                        .add("editable", ["attribute", "value"])
                ])
            ];
        })
            .commit("If a table is field editable, clear any excess empty fields.", function (_a) {
            var find = _a.find, lookup = _a.lookup, not = _a.not, choose = _a.choose, record = _a.record;
            var table = find("ui/field-table", { editable: "field" });
            var table_alias = find("ui/field-table", { editable: "field" });
            table == table_alias;
            // Two new fields exist
            var field = find("ui/field-table/field/new");
            var other_field = find("ui/field-table/field/new");
            // In the same table
            table.field == field;
            table_alias.field == other_field;
            // Both are empty
            not(function () { return table.change.field == field; });
            not(function () { return table_alias.change.field == other_field; });
            // And the other is before this one.
            other_field.sort < field.sort;
            return [field.remove()];
        })
            .bind("Each field row has an attribute and a value set.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var field_row = find("ui/field-table/row");
            var table = field_row.table, field = field_row.field;
            var sort = choose(function () { return field.sort; }, function () { return field.attribute; }, function () { return 1; })[0];
            var editable = choose(function () { field.editable == "attribute"; return "true"; }, function () { return "false"; })[0];
            return [
                field_row.add({ tag: "html/element", tagname: "tr", sort: sort }).add("children", [
                    record("html/element", { sort: 1, tagname: "td", table: table, field: field }).add("children", [
                        record("ui/field-table/attribute", "ui/field-table/cell", { table: table, field: field, value_row: field, column: "attribute" })
                            .add("editable", editable)
                    ]),
                    record("html/element", { sort: 2, tagname: "td", table: table, field: field }).add("children", [
                        record("ui/field-table/value-set", "ui/column", { table: table, field: field })
                    ])
                ])
            ];
        })
            .bind("Create a value for each field value in the value set.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var value_set = find("ui/field-table/value-set");
            var table = value_set.table, field = value_set.field;
            var value_row = table.value_row;
            value_row.field == field;
            var value = value_row.value, editable = value_row.editable;
            var sort = choose(function () { return value_row.sort; }, function () { return value; })[0];
            return [
                value_set.add("children", [
                    record("ui/field-table/value", "ui/field-table/cell", { sort: sort, table: table, field: field, value_row: value_row, column: "value", editable: editable }),
                ])
            ];
        })
            .bind("The initial value of a cell is pulled off it's value_row or field.", function (_a) {
            var find = _a.find, choose = _a.choose, not = _a.not, lookup = _a.lookup, record = _a.record;
            var cell = find("ui/field-table/cell");
            var field = cell.field, value_row = cell.value_row, column = cell.column;
            var _b = lookup(value_row), attribute = _b.attribute, initial = _b.value;
            attribute == column;
            return [cell.add("initial", initial)];
        })
            .bind("Draw field cells as text if they're not editable.", function (_a) {
            var find = _a.find;
            var cell = find("ui/field-table/cell", { editable: "false" });
            var field = cell.field, column = cell.column, initial = cell.initial;
            return [cell.add({ tag: "ui/text", text: initial })];
        })
            .bind("Draw field cells as inputs when they're editable.", function (_a) {
            var find = _a.find;
            var cell = find("ui/field-table/cell", { editable: "true" });
            var field = cell.field, column = cell.column, initial = cell.initial;
            return [cell.add({ tag: ["ui/input", "html/autosize-input"], placeholder: column + "..." })];
        })
            .bind("When a cell changes value, update the tables changes list.", function (_a) {
            var find = _a.find, lookup = _a.lookup, record = _a.record;
            var cell = find("ui/field-table/cell");
            var table = cell.table, field = cell.field, column = cell.column, value = cell.value, value_row = cell.value_row, initial = cell.initial;
            field.editable == column;
            value != initial;
            return [table.add("change", [
                    record("ui/field-change", { field: field }).add("cell", [
                        record({ column: column, initial: initial, value: value })
                    ])
                ])];
        });
        this.autocomplete();
    };
    //--------------------------------------------------------------------
    // Autocomplete
    //--------------------------------------------------------------------
    UIWatcher.prototype.autocomplete = function () {
        this.program
            .bind("Decorate autocompletes.", function (_a) {
            var find = _a.find, record = _a.record;
            var autocomplete = find("ui/autocomplete");
            return [
                autocomplete.add({ tag: "ui/column" }).add("children", [
                    record("ui/autocomplete/input", "ui/input", { sort: 1, autocomplete: autocomplete })
                ])
            ];
        })
            .bind("Copy input placeholder.", function (_a) {
            var find = _a.find;
            var input = find("ui/autocomplete/input");
            return [input.add({ placeholder: input.autocomplete.placeholder })];
        })
            .bind("Copy input initial.", function (_a) {
            var find = _a.find;
            var input = find("ui/autocomplete/input");
            return [input.add({ initial: input.autocomplete.initial })];
        })
            .bind("Copy trigger focus.", function (_a) {
            var find = _a.find;
            var autocomplete = find("ui/autocomplete", "html/trigger/focus");
            var input = find("ui/autocomplete/input", { autocomplete: autocomplete });
            return [input.add({ tag: "html/trigger/focus" })];
        })
            .bind("Copy autosize input.", function (_a) {
            var find = _a.find;
            var autocomplete = find("ui/autocomplete", "html/autosize-input");
            var input = find("ui/autocomplete/input", { autocomplete: autocomplete });
            return [input.add({ tag: "html/autosize-input" })];
        })
            .bind("An autocompletes value is it's input's.", function (_a) {
            var find = _a.find, choose = _a.choose;
            var input = find("ui/autocomplete/input");
            var value = choose(function () { return input.value; }, function () { return ""; })[0];
            return [input.autocomplete.add("value", value)];
        })
            .commit("If an autocomplete's value disagrees with it's selected, clear the selected.", function (_a) {
            var find = _a.find;
            var autocomplete = find("ui/autocomplete");
            var selected = autocomplete.selected, value = autocomplete.value;
            selected.text != value;
            return [autocomplete.remove("selected")];
        })
            .bind("Completions that match the current input value are matches.", function (_a) {
            var find = _a.find, string = _a.lib.string;
            var autocomplete = find("ui/autocomplete");
            var value = autocomplete.value, completion = autocomplete.completion;
            var ix = string["index-of"](string.lowercase(completion.text), string.lowercase(value));
            return [autocomplete.add("match", completion)];
        })
            .bind("Matches are sorted by length.", function (_a) {
            var find = _a.find, string = _a.lib.string;
            var autocomplete = find("ui/autocomplete");
            var match = autocomplete.match;
            var sort = string["codepoint-length"](match.text);
            return [match.add("sort", sort)];
        })
            .bind("Show the matches in a popout beneath the input.", function (_a) {
            var find = _a.find, lookup = _a.lookup, record = _a.record;
            var autocomplete = find("ui/autocomplete");
            var match = autocomplete.match;
            var _b = lookup(match), attribute = _b.attribute, value = _b.value;
            attribute != "tag";
            return [
                autocomplete.add("children", [
                    record("ui/autocomplete/matches", "ui/column", { sort: 2, autocomplete: autocomplete }).add("children", [
                        record("ui/autocomplete/match", "ui/text", { autocomplete: autocomplete, match: match, sort: match.sort }).add(attribute, value)
                    ])
                ])
            ];
        });
        //--------------------------------------------------------------------
        // Autocomplete Interaction
        //--------------------------------------------------------------------
        this.program
            .commit("Clicking a match updates the selected and value of the autocomplete.", function (_a) {
            var find = _a.find, record = _a.record;
            var ui_match = find("ui/autocomplete/match");
            find("html/event/mouse-down", { element: ui_match });
            var autocomplete = ui_match.autocomplete, match = ui_match.match;
            return [
                record("ui/event/select", { autocomplete: autocomplete, selected: match }),
            ];
        })
            .commit("Focusing an autocomplete input opens the autocomplete.", function (_a) {
            var find = _a.find, record = _a.record;
            var input = find("ui/autocomplete/input");
            find("html/event/focus", { element: input });
            return [record("ui/event/open", { autocomplete: input.autocomplete })];
        })
            .commit("Blurring an autocomplete input closes the autocomplete.", function (_a) {
            var find = _a.find, record = _a.record;
            var input = find("ui/autocomplete/input");
            find("html/event/blur", { element: input });
            return [record("ui/event/close", { autocomplete: input.autocomplete })];
        })
            .commit("If the value matches perfectly on blur, select that match.", function (_a) {
            var find = _a.find, string = _a.lib.string, record = _a.record;
            var input = find("ui/autocomplete/input");
            var value = find("html/event/blur", { element: input }).value;
            var autocomplete = input.autocomplete;
            var match = autocomplete.match;
            string.lowercase(match.text) == string.lowercase(value);
            return [record("ui/event/select", { autocomplete: autocomplete, selected: match })];
        })
            .commit("Pressing escape in an open autocomplete closes it.", function (_a) {
            var find = _a.find, not = _a.not, record = _a.record;
            var autocomplete = find("ui/autocomplete", { open: "true" });
            find("html/event/key-down", { key: "escape", element: autocomplete });
            return [record("ui/event/close", { autocomplete: autocomplete })];
        })
            .commit("Pressing enter in an open autocomplete submits it.", function (_a) {
            var find = _a.find, record = _a.record;
            var autocomplete = find("ui/autocomplete", { open: "true" });
            find("html/event/key-down", { key: "enter", element: autocomplete });
            return [
                record("ui/event/submit", { autocomplete: autocomplete }),
                record("ui/event/close", { autocomplete: autocomplete })
            ];
        })
            .commit("Pressing tab in an open autocomplete selects the top match.", function (_a) {
            var find = _a.find, gather = _a.gather, record = _a.record;
            var autocomplete = find("ui/autocomplete", { open: "true" });
            find("html/event/key-down", { key: "tab", element: autocomplete });
            var match = autocomplete.match;
            1 == gather(match.sort).per(autocomplete).sort();
            return [
                record("ui/event/select", { autocomplete: autocomplete, selected: match }),
                record("ui/event/close", { autocomplete: autocomplete })
            ];
        });
        //--------------------------------------------------------------------
        // Autocomplete Events
        //--------------------------------------------------------------------
        this.program
            .commit("Clear the specified autocomplete.", function (_a) {
            var find = _a.find;
            var event = find("ui/event/clear");
            var autocomplete = event.autocomplete;
            var input = find("ui/autocomplete/input", { autocomplete: autocomplete });
            return [
                input.remove("value"),
                event.remove()
            ];
        })
            .commit("When an autocomplete is opened, store it's previous value.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var event = find("ui/event/open");
            var autocomplete = event.autocomplete;
            var input = find("ui/autocomplete/input", { autocomplete: autocomplete });
            var value = choose(function () { return autocomplete.previous; }, function () { return autocomplete.value; }, function () { return ""; })[0];
            return [
                autocomplete.remove("open").add({ open: "true", previous: value }),
                input.remove("tag", "html/trigger/blur"),
                event.remove()
            ];
        })
            .commit("When an autocomplete is closed, erase it's previous value.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var event = find("ui/event/close");
            var autocomplete = event.autocomplete;
            var input = find("ui/autocomplete/input", { autocomplete: autocomplete });
            return [
                autocomplete.remove("open").remove("previous"),
                input.add("tag", "html/trigger/blur"),
                autocomplete.remove("tag", "html/trigger/focus"),
                event.remove()
            ];
        })
            .commit("When an autocomplete is closed, and it's value is changed, emit a change event.", function (_a) {
            var find = _a.find, choose = _a.choose, record = _a.record;
            var event = find("ui/event/close");
            var autocomplete = event.autocomplete;
            autocomplete.value != autocomplete.previous;
            return [
                record("ui/event/change", { autocomplete: autocomplete, value: autocomplete.value })
            ];
        })
            .commit("Selecting a completion updates the autocomplete.", function (_a) {
            var find = _a.find, record = _a.record;
            var event = find("ui/event/select");
            var autocomplete = event.autocomplete, selected = event.selected;
            var input = find("ui/autocomplete/input", { autocomplete: autocomplete });
            return [
                input.remove("value").add("value", selected.text),
                autocomplete.remove("selected").add("selected", selected),
                event.remove()
            ];
        })
            .commit("When a selection is made and it's different from the previous value, emit a change event.", function (_a) {
            var find = _a.find, record = _a.record;
            var event = find("ui/event/select");
            var autocomplete = event.autocomplete, selected = event.selected;
            selected.text != autocomplete.previous;
            return [
                record("ui/event/change", { autocomplete: autocomplete, value: selected.text })
            ];
        })
            .commit("Clear the autocomplete change event.", function (_a) {
            var find = _a.find, record = _a.record;
            var event = find("ui/event/change");
            var autocomplete = event.autocomplete;
            return [event.remove()];
        });
    };
    UIWatcher.helpers = {
        $style: function (attrs) {
            return UIWatcher._addAttrs(uuid_1.v4(), attrs);
        },
        $elem: UIWatcher.$elem,
        $text: function (text, attrs) {
            var eavs = UIWatcher.$elem("ui/text", attrs);
            var id = eavs[0][0];
            eavs.push([id, "text", text]);
            return eavs;
        },
        $button: function (attrs) {
            return UIWatcher.$elem("ui/button", attrs);
        },
        $row: UIWatcher._makeContainer("ui/row"),
        $column: UIWatcher._makeContainer("ui/column"),
    };
    return UIWatcher;
}(watcher_1.Watcher));
exports.UIWatcher = UIWatcher;
watcher_1.Watcher.register("ui", UIWatcher);
//# sourceMappingURL=ui.js.map